import * as axios from 'axios';
import { AxiosRequestConfig, AxiosInstance, AxiosPromise } from 'axios';

/**
 * Dopt Users API
 * The Dopt Users API
 *
 * The version of the OpenAPI document: 0.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
interface ConfigurationParameters {
    apiKey?: string | Promise<string> | ((name: string) => string) | ((name: string) => Promise<string>);
    username?: string;
    password?: string;
    accessToken?: string | Promise<string> | ((name?: string, scopes?: string[]) => string) | ((name?: string, scopes?: string[]) => Promise<string>);
    basePath?: string;
    baseOptions?: any;
    formDataCtor?: new () => any;
}
declare class Configuration {
    /**
     * parameter for apiKey security
     * @param name security name
     * @memberof Configuration
     */
    apiKey?: string | Promise<string> | ((name: string) => string) | ((name: string) => Promise<string>);
    /**
     * parameter for basic security
     *
     * @type {string}
     * @memberof Configuration
     */
    username?: string;
    /**
     * parameter for basic security
     *
     * @type {string}
     * @memberof Configuration
     */
    password?: string;
    /**
     * parameter for oauth2 security
     * @param name security name
     * @param scopes oauth2 scope
     * @memberof Configuration
     */
    accessToken?: string | Promise<string> | ((name?: string, scopes?: string[]) => string) | ((name?: string, scopes?: string[]) => Promise<string>);
    /**
     * override base path
     *
     * @type {string}
     * @memberof Configuration
     */
    basePath?: string;
    /**
     * base options for axios calls
     *
     * @type {any}
     * @memberof Configuration
     */
    baseOptions?: any;
    /**
     * The FormData constructor that will be used to create multipart form data
     * requests. You can inject this here so that execution environments that
     * do not support the FormData class can still run the generated client.
     *
     * @type {new () => FormData}
     */
    formDataCtor?: new () => any;
    constructor(param?: ConfigurationParameters);
    /**
     * Check if the given MIME is a JSON MIME.
     * JSON MIME examples:
     *   application/json
     *   application/json; charset=UTF8
     *   APPLICATION/JSON
     *   application/vnd.company+json
     * @param mime - MIME (Multipurpose Internet Mail Extensions)
     * @return True if the given MIME is JSON, false otherwise.
     */
    isJsonMime(mime: string): boolean;
}

/**
 * Dopt Users API
 * The Dopt Users API
 *
 * The version of the OpenAPI document: 0.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/**
 *
 * @export
 * @interface RequestArgs
 */
interface RequestArgs {
    url: string;
    options: AxiosRequestConfig;
}
/**
 *
 * @export
 * @class BaseAPI
 */
declare class BaseAPI {
    protected basePath: string;
    protected axios: AxiosInstance;
    protected configuration: Configuration | undefined;
    constructor(configuration?: Configuration, basePath?: string, axios?: AxiosInstance);
}

/**
 *
 * @export
 * @interface BadRequestErrorResponseBody
 */
interface BadRequestErrorResponseBody {
    /**
     *
     * @type {BadRequestErrorResponseBodyCode}
     * @memberof BadRequestErrorResponseBody
     */
    'code': BadRequestErrorResponseBodyCode;
    /**
     *
     * @type {string}
     * @memberof BadRequestErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface BadRequestErrorResponseBodyCode
 */
interface BadRequestErrorResponseBodyCode {
}
/**
 *
 * @export
 * @interface IdentifyBulkRequestBodyInner
 */
interface IdentifyBulkRequestBodyInner {
    [key: string]: any;
    /**
     *
     * @type {string}
     * @memberof IdentifyBulkRequestBodyInner
     */
    '__dopt_identifier': string;
}
/**
 *
 * @export
 * @interface IdentifyBulkResponseBody
 */
interface IdentifyBulkResponseBody {
    /**
     *
     * @type {number}
     * @memberof IdentifyBulkResponseBody
     */
    'count': number;
}
/**
 *
 * @export
 * @interface IdentifyRequestParams
 */
interface IdentifyRequestParams {
    /**
     *
     * @type {string}
     * @memberof IdentifyRequestParams
     */
    'identifier': string;
}
/**
 *
 * @export
 * @interface IdentifySegmentRequestBody
 */
interface IdentifySegmentRequestBody {
    /**
     *
     * @type {string}
     * @memberof IdentifySegmentRequestBody
     */
    'userId': string;
    /**
     *
     * @type {{ [key: string]: any; }}
     * @memberof IdentifySegmentRequestBody
     */
    'traits': {
        [key: string]: any;
    };
}
/**
 *
 * @export
 * @interface IdentifySegmentResponseBody
 */
interface IdentifySegmentResponseBody {
    /**
     *
     * @type {number}
     * @memberof IdentifySegmentResponseBody
     */
    'count': number;
}
/**
 *
 * @export
 * @interface InternalServerErrorResponseBody
 */
interface InternalServerErrorResponseBody {
    /**
     *
     * @type {InternalServerErrorResponseBodyCode}
     * @memberof InternalServerErrorResponseBody
     */
    'code': InternalServerErrorResponseBodyCode;
    /**
     *
     * @type {string}
     * @memberof InternalServerErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface InternalServerErrorResponseBodyCode
 */
interface InternalServerErrorResponseBodyCode {
}
/**
 *
 * @export
 * @interface NotFoundErrorResponseBody
 */
interface NotFoundErrorResponseBody {
    /**
     *
     * @type {NotFoundErrorResponseBodyCode}
     * @memberof NotFoundErrorResponseBody
     */
    'code': NotFoundErrorResponseBodyCode;
    /**
     *
     * @type {string}
     * @memberof NotFoundErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface NotFoundErrorResponseBodyCode
 */
interface NotFoundErrorResponseBodyCode {
}
/**
 *
 * @export
 * @interface UnauthorizedErrorResponseBody
 */
interface UnauthorizedErrorResponseBody {
    /**
     *
     * @type {UnauthorizedErrorResponseBodyCode}
     * @memberof UnauthorizedErrorResponseBody
     */
    'code': UnauthorizedErrorResponseBodyCode;
    /**
     *
     * @type {string}
     * @memberof UnauthorizedErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface UnauthorizedErrorResponseBodyCode
 */
interface UnauthorizedErrorResponseBodyCode {
}
/**
 * IdentifyApi - axios parameter creator
 * @export
 */
declare const IdentifyApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @param {string} identifier
     * @param {{ [key: string]: any; }} [requestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identify: (identifier: string, requestBody?: {
        [key: string]: any;
    } | undefined, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {Array<IdentifyBulkRequestBodyInner>} [identifyBulkRequestBodyInner]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifyBulk: (identifyBulkRequestBodyInner?: Array<IdentifyBulkRequestBodyInner>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {IdentifySegmentRequestBody} [identifySegmentRequestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifySegment: (identifySegmentRequestBody?: IdentifySegmentRequestBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * IdentifyApi - functional programming interface
 * @export
 */
declare const IdentifyApiFp: (configuration?: Configuration) => {
    /**
     *
     * @param {string} identifier
     * @param {{ [key: string]: any; }} [requestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identify(identifier: string, requestBody?: {
        [key: string]: any;
    } | undefined, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @param {Array<IdentifyBulkRequestBodyInner>} [identifyBulkRequestBodyInner]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifyBulk(identifyBulkRequestBodyInner?: Array<IdentifyBulkRequestBodyInner>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<IdentifyBulkResponseBody>>;
    /**
     *
     * @param {IdentifySegmentRequestBody} [identifySegmentRequestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifySegment(identifySegmentRequestBody?: IdentifySegmentRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
};
/**
 * IdentifyApi - factory interface
 * @export
 */
declare const IdentifyApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @param {string} identifier
     * @param {{ [key: string]: any; }} [requestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identify(identifier: string, requestBody?: {
        [key: string]: any;
    } | undefined, options?: any): AxiosPromise<void>;
    /**
     *
     * @param {Array<IdentifyBulkRequestBodyInner>} [identifyBulkRequestBodyInner]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifyBulk(identifyBulkRequestBodyInner?: Array<IdentifyBulkRequestBodyInner>, options?: any): AxiosPromise<IdentifyBulkResponseBody>;
    /**
     *
     * @param {IdentifySegmentRequestBody} [identifySegmentRequestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    identifySegment(identifySegmentRequestBody?: IdentifySegmentRequestBody, options?: any): AxiosPromise<void>;
};
/**
 * IdentifyApi - object-oriented interface
 * @export
 * @class IdentifyApi
 * @extends {BaseAPI}
 */
declare class IdentifyApi extends BaseAPI {
    /**
     *
     * @param {string} identifier
     * @param {{ [key: string]: any; }} [requestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof IdentifyApi
     */
    identify(identifier: string, requestBody?: {
        [key: string]: any;
    }, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<void, any>>;
    /**
     *
     * @param {Array<IdentifyBulkRequestBodyInner>} [identifyBulkRequestBodyInner]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof IdentifyApi
     */
    identifyBulk(identifyBulkRequestBodyInner?: Array<IdentifyBulkRequestBodyInner>, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<IdentifyBulkResponseBody, any>>;
    /**
     *
     * @param {IdentifySegmentRequestBody} [identifySegmentRequestBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof IdentifyApi
     */
    identifySegment(identifySegmentRequestBody?: IdentifySegmentRequestBody, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<void, any>>;
}

export { BadRequestErrorResponseBody, BadRequestErrorResponseBodyCode, Configuration, ConfigurationParameters, IdentifyApi, IdentifyApiAxiosParamCreator, IdentifyApiFactory, IdentifyApiFp, IdentifyBulkRequestBodyInner, IdentifyBulkResponseBody, IdentifyRequestParams, IdentifySegmentRequestBody, IdentifySegmentResponseBody, InternalServerErrorResponseBody, InternalServerErrorResponseBodyCode, NotFoundErrorResponseBody, NotFoundErrorResponseBodyCode, UnauthorizedErrorResponseBody, UnauthorizedErrorResponseBodyCode };
